package sha256

import (
	// Standard
	"crypto/sha256"
	"crypto/subtle"
)

// Check Hash
func (Algorithm) CheckHash(data []byte, hashToCheck []byte) (bool, error) {
	// Hasher
	hasher := sha256.New()
	// Write To Hasher
	_, err := hasher.Write(data)
	// Handle Error
	if err != nil {
		return false, err
	}
	// Return Hash
	return subtle.ConstantTimeCompare(hasher.Sum(nil), hashToCheck) == 1, err
}
